
#define FILE_DEVICE_KRNLDRVR 0x80FF

#define NT_DEVICE_NAME	    L"\\Device\\A1216E0"
#define DOS_DEVICE_NAME     L"\\DosDevices\\A1216E"

#define IOCTL_A1216E_INIT_DRIVER		CTL_CODE(FILE_DEVICE_KRNLDRVR, 0x801, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_A1216E_STATUS				CTL_CODE(FILE_DEVICE_KRNLDRVR, 0x802, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_A1216E_STOP				CTL_CODE(FILE_DEVICE_KRNLDRVR, 0x803, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_A1216E_GETDATA			CTL_CODE(FILE_DEVICE_KRNLDRVR, 0x804, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_A1216E_INIT_CHANNEL_TABLE	CTL_CODE(FILE_DEVICE_KRNLDRVR, 0x805, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_A1216E_INIT_GAIN_TABLE	CTL_CODE(FILE_DEVICE_KRNLDRVR, 0x806, METHOD_BUFFERED, FILE_ANY_ACCESS)

typedef struct _A1216E_DEVICE_EXTENSION {
    PDEVICE_OBJECT DeviceObject;
	PKINTERRUPT InterruptObject;
	ULONG BaseAddress;
	UCHAR IRQ;
	LONG NumPoints;
	LONG PointsRemaining;
	LONG Index;
	LONG NumChannelEntries;
	PULONG DataBuffer;
	PSHORT ChannelTable;
	UCHAR GainTable[256];
	BOOLEAN IntDisabled;
	BOOLEAN InterruptConnected;
	BOOLEAN DataBufferAllocated;
	BOOLEAN ChannelTableAllocated;
	BOOLEAN IRQCleared;
} A1216E_DEVICE_EXTENSION, *PA1216E_DEVICE_EXTENSION;


typedef struct _A1216E_INIT_DATA {
	ULONG BaseAddress;
	ULONG IRQ;
	LONG NumPoints;
	LONG BusType;
	ULONG BusNumber;
} A1216E_INIT_DATA, *PA1216E_INIT_DATA;

VOID
A1216E_SetChannel(
	IN LONG Ch,
	IN PA1216E_DEVICE_EXTENSION extension
	);

BOOLEAN
A1216EInterruptServiceRoutine(
    IN PKINTERRUPT Interrupt,
    IN OUT PVOID Context
    );

NTSTATUS
A1216EOpenClose(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    );

VOID
A1216EUnload(
    IN PDRIVER_OBJECT DriverObject
    );

NTSTATUS
A1216EDeviceControl(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    );

VOID
A1216ECancelIrp(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    );
